echo "List Benchmark - long transaction - read 50% - 32 threads - 1 tx/thread - small list"
echo
:>"experiments/results/list/long-list-r50-p32-1tx-small.csv"
for i in 100 200 500 800 1000
do
	inval_time=0
	norec_time=0
	riv1_time=0
	riv3_time=0
	
for (( j = 1 ; j <= 5; j++ ))
do

	export STM_CONFIG=TLI
	temp=$(echo "$(./../rstm_build/bench/ListNInsertsBenchSSB64 -p 32 -m 4096 -R 50 -N 100 -O $i -X 1)" | egrep -e 'time=[^ ]*' -o | cut -d = -f 2)
	inval_time=$(echo $inval_time $temp | awk ' { printf "%f\n", $1 + $2 } ') 

	export STM_CONFIG=NOrec
	temp=$(echo "$(./../rstm_build/bench/ListNInsertsBenchSSB64 -p 32 -m 4096 -R 50 -N 100 -O $i -X 1)" | egrep -e 'time=[^ ]*' -o | cut -d = -f 2)
	norec_time=$(echo $norec_time $temp | awk ' { printf "%f\n", $1 + $2 } ')

	export STM_CONFIG=RIV1
	temp=$(echo "$(./../rstm_build/bench/ListNInsertsBenchSSB64 -p 32 -m 5000 -R 50 -N 100 -O $i -X 1)" | egrep -e 'time=[^ ]*' -o | cut -d = -f 2)
	riv1_time=$(echo $riv1_time $temp | awk ' { printf "%f\n", $1 + $2 } ')

	export STM_CONFIG=RIV3
	temp=$(echo "$(./../rstm_build/bench/ListNInsertsBenchSSB64 -p 32 -m 4096 -R 50 -N 100 -O $i -X 1)" | egrep -e 'time=[^ ]*' -o | cut -d = -f 2)
	riv3_time=$(echo $riv3_time $temp | awk ' { printf "%f\n", $1 + $2 } ')
	
done

	inval_time=$(echo $inval_time 5000000000.0 | awk ' { printf "%f\n", $1 / $2 } ') 
	riv3_time=$(echo $riv3_time 5000000000.0 | awk ' { printf "%f\n", $1 / $2 } ')
	norec_time=$(echo $norec_time 5000000000.0 | awk ' { printf "%f\n", $1 / $2 } ')
	riv1_time=$(echo $riv1_time 5000000000.0 | awk ' { printf "%f\n", $1 / $2 } ')

	echo "Number of threads: " $i
	echo "Inval: " $inval_time
	echo "NOrec: " $norec_time
	echo "RIV1: " $riv1_time
	echo "RIV3: " $riv3_time	
	echo

	echo $i $inval_time $norec_time $riv1_time $riv3_time >> "experiments/results/list/long-list-r50-p32-1tx-small.csv"
	
done

#==========================================================================================================================

echo "List Benchmark - long transaction - read 50% - 32 threads - 1 second - small list"
echo
:>"experiments/results/list/long-list-r50-p32-1sec-small.csv"
for i in 100 200 500 800 1000
do
	inval_throughput=0
	norec_throughput=0
	riv1_throughput=0
	riv3_throughput=0
	
for (( j = 1 ; j <= 5; j++ ))
do

	export STM_CONFIG=TLI
	inval_throughput=`expr $inval_throughput + $(echo "$(./../rstm_build/bench/ListNInsertsBenchSSB64 -p 32 -m 4096 -R 50 -N 100 -O $i)" | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)`

	export STM_CONFIG=NOrec
	norec_throughput=`expr $norec_throughput + $(echo "$(./../rstm_build/bench/ListNInsertsBenchSSB64 -p 32 -m 4096 -R 50 -N 100 -O $i)" | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)`

	export STM_CONFIG=RIV1
	riv1_throughput=`expr $riv1_throughput + $(echo "$(./../rstm_build/bench/ListNInsertsBenchSSB64 -p 32 -m 4096 -R 50 -N 100 -O $i)" | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)`

	export STM_CONFIG=RIV3
	riv3_throughput=`expr $riv3_throughput + $(echo "$(./../rstm_build/bench/ListNInsertsBenchSSB64 -p 32 -m 4096 -R 50 -N 100 -O $i)" | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)`

done

	inval_throughput=`expr $inval_throughput / 5`
	norec_throughput=`expr $norec_throughput / 5`
	riv1_throughput=`expr $riv1_throughput / 5`
	riv3_throughput=`expr $riv3_throughput / 5`

	echo "Number of threads: " $i
	echo "Inval: " $inval_throughput
	echo "NOrec: " $norec_throughput
	echo "RIV1: " $riv1_throughput
	echo "RIV3: " $riv3_throughput	
	echo

	echo $i $inval_throughput $norec_throughput $riv1_throughput $riv3_throughput >> "experiments/results/list/long-list-r50-p32-1sec-small.csv"
	
done

#==========================================================================================================================

echo "List Benchmark - long transaction - read 50% - 32 threads - 1 tx/thread - large list"
echo
:>"experiments/results/list/long-list-r50-p32-1tx-large.csv"
for i in 100 200 500 800 1000
do
	inval_time=0
	norec_time=0
	riv1_time=0
	riv3_time=0
	
for (( j = 1 ; j <= 5; j++ ))
do

	export STM_CONFIG=TLI
	temp=$(echo "$(./../rstm_build/bench/ListNInsertsBenchSSB64 -p 32 -m 100000 -R 50 -N 100 -O $i -X 1)" | egrep -e 'time=[^ ]*' -o | cut -d = -f 2)
	inval_time=$(echo $inval_time $temp | awk ' { printf "%f\n", $1 + $2 } ') 

	export STM_CONFIG=NOrec
	temp=$(echo "$(./../rstm_build/bench/ListNInsertsBenchSSB64 -p 32 -m 100000 -R 50 -N 100 -O $i -X 1)" | egrep -e 'time=[^ ]*' -o | cut -d = -f 2)
	norec_time=$(echo $norec_time $temp | awk ' { printf "%f\n", $1 + $2 } ')

	export STM_CONFIG=RIV1
	temp=$(echo "$(./../rstm_build/bench/ListNInsertsBenchSSB64 -p 32 -m 100000 -R 50 -N 100 -O $i -X 1)" | egrep -e 'time=[^ ]*' -o | cut -d = -f 2)
	riv1_time=$(echo $riv1_time $temp | awk ' { printf "%f\n", $1 + $2 } ')

	export STM_CONFIG=RIV3
	temp=$(echo "$(./../rstm_build/bench/ListNInsertsBenchSSB64 -p 32 -m 100000 -R 50 -N 100 -O $i -X 1)" | egrep -e 'time=[^ ]*' -o | cut -d = -f 2)
	riv3_time=$(echo $riv3_time $temp | awk ' { printf "%f\n", $1 + $2 } ')
	
done

	inval_time=$(echo $inval_time 5000000000.0 | awk ' { printf "%f\n", $1 / $2 } ') 
	riv3_time=$(echo $riv3_time 5000000000.0 | awk ' { printf "%f\n", $1 / $2 } ')
	norec_time=$(echo $norec_time 5000000000.0 | awk ' { printf "%f\n", $1 / $2 } ')
	riv1_time=$(echo $riv1_time 5000000000.0 | awk ' { printf "%f\n", $1 / $2 } ')

	echo "Number of threads: " $i
	echo "Inval: " $inval_time
	echo "NOrec: " $norec_time
	echo "RIV1: " $riv1_time
	echo "RIV3: " $riv3_time	
	echo

	echo $i $inval_time $norec_time $riv1_time $riv3_time >> "experiments/results/list/long-list-r50-p32-1tx-large.csv"
	
done

#==========================================================================================================================

echo "List Benchmark - long transaction - read 50% - 32 threads - 1 second"
echo
:>"experiments/results/list/long-list-r50-p32-1sec-large.csv"
for i in 100 200 500 800 1000
do
	inval_throughput=0
	norec_throughput=0
	riv1_throughput=0
	riv3_throughput=0
	
for (( j = 1 ; j <= 5; j++ ))
do

	export STM_CONFIG=TLI
	inval_throughput=`expr $inval_throughput + $(echo "$(./../rstm_build/bench/ListNInsertsBenchSSB64 -p 32 -m 100000 -R 50 -N 100 -O $i)" | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)`

	export STM_CONFIG=NOrec
	norec_throughput=`expr $norec_throughput + $(echo "$(./../rstm_build/bench/ListNInsertsBenchSSB64 -p 32 -m 100000 -R 50 -N 100 -O $i)" | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)`

	export STM_CONFIG=RIV1
	riv1_throughput=`expr $riv1_throughput + $(echo "$(./../rstm_build/bench/ListNInsertsBenchSSB64 -p 32 -m 100000 -R 50 -N 100 -O $i)" | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)`

	export STM_CONFIG=RIV3
	riv3_throughput=`expr $riv3_throughput + $(echo "$(./../rstm_build/bench/ListNInsertsBenchSSB64 -p 32 -m 100000 -R 50 -N 100 -O $i)" | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)`

done

	inval_throughput=`expr $inval_throughput / 5`
	norec_throughput=`expr $norec_throughput / 5`
	riv1_throughput=`expr $riv1_throughput / 5`
	riv3_throughput=`expr $riv3_throughput / 5`

	echo "Number of threads: " $i
	echo "Inval: " $inval_throughput
	echo "NOrec: " $norec_throughput
	echo "RIV1: " $riv1_throughput
	echo "RIV3: " $riv3_throughput	
	echo

	echo $i $inval_throughput $norec_throughput $riv1_throughput $riv3_throughput >> "experiments/results/list/long-list-r50-p32-1sec-large.csv"
	
done
