#set terminal png         # gnuplot recommends setting terminal before output
set terminal postscript eps enhanced mono dashed lw 1 "Helvetica" 30
set pointsize 2                              # larger point!
set key top
set key left
set autoscale
set xlabel "Threads"

set ylabel "Time (in seconds)"

set output "results/stamp/kmeans.eps"  # The output filename;
plot	"results/stamp/kmeans.csv" using 1:2 title "Inval" with linespoints lt 2 pt 2, \
	"results/stamp/kmeans.csv" using 1:3 title "NOrec" with linespoints lt 3 pt 3, \
	"results/stamp/kmeans.csv" using 1:4 title "RIV1" with linespoints lt 4 pt 4, \
	"results/stamp/kmeans.csv" using 1:5 title "RIV2" with linespoints lt 5 pt 5

set output "results/stamp/ssca2.eps"  # The output filename;
plot	"results/stamp/ssca2.csv" using 1:2 title "Inval" with linespoints lt 2 pt 2, \
	"results/stamp/ssca2.csv" using 1:3 title "NOrec" with linespoints lt 3 pt 3, \
	"results/stamp/ssca2.csv" using 1:4 title "RIV1" with linespoints lt 4 pt 4, \
	"results/stamp/ssca2.csv" using 1:5 title "RIV2" with linespoints lt 5 pt 5

set output "results/stamp/labyrinth.eps"  # The output filename;
plot	"results/stamp/labyrinth.csv" using 1:2 title "Inval" with linespoints lt 2 pt 2, \
	"results/stamp/labyrinth.csv" using 1:3 title "NOrec" with linespoints lt 3 pt 3, \
	"results/stamp/labyrinth.csv" using 1:4 title "RIV1" with linespoints lt 4 pt 4, \
	"results/stamp/labyrinth.csv" using 1:5 title "RIV2" with linespoints lt 5 pt 5

set output "results/stamp/intruder.eps"  # The output filename;
plot	"results/stamp/intruder.csv" using 1:2 title "Inval" with linespoints lt 2 pt 2, \
	"results/stamp/intruder.csv" using 1:3 title "NOrec" with linespoints lt 3 pt 3, \
	"results/stamp/intruder.csv" using 1:4 title "RIV1" with linespoints lt 4 pt 4, \
	"results/stamp/intruder.csv" using 1:5 title "RIV2" with linespoints lt 5 pt 5

set output "results/stamp/genome.eps"  # The output filename;
plot	"results/stamp/genome.csv" using 1:2 title "Inval" with linespoints lt 2 pt 2, \
	"results/stamp/genome.csv" using 1:3 title "NOrec" with linespoints lt 3 pt 3, \
	"results/stamp/genome.csv" using 1:4 title "RIV1" with linespoints lt 4 pt 4, \
	"results/stamp/genome.csv" using 1:5 title "RIV2" with linespoints lt 5 pt 5

set output "results/stamp/vacation.eps"  # The output filename;
plot	"results/stamp/vacation.csv" using 1:2 title "Inval" with linespoints lt 2 pt 2, \
	"results/stamp/vacation.csv" using 1:3 title "NOrec" with linespoints lt 3 pt 3, \
	"results/stamp/vacation.csv" using 1:4 title "RIV1" with linespoints lt 4 pt 4, \
	"results/stamp/vacation.csv" using 1:5 title "RIV2" with linespoints lt 5 pt 5

set output "results/stamp/bayes.eps"  # The output filename;
plot	"results/stamp/bayes.csv" using 1:2 title "Inval" with linespoints lt 2 pt 2, \
	"results/stamp/bayes.csv" using 1:3 title "NOrec" with linespoints lt 3 pt 3, \
	"results/stamp/bayes.csv" using 1:4 title "RIV1" with linespoints lt 4 pt 4, \
	"results/stamp/bayes.csv" using 1:5 title "RIV2" with linespoints lt 5 pt 5
